{ open Parser }


rule token=parse 
| "/*"     { comment lexbuf }           (* Comments *)
| [' ' '\t' '\r' '\n'] { token lexbuf } (* Whitespace *)     
| '('                   {LPAREN}
| ')'                   {RPAREN}
| '{'                   {LBRACE}
| '}'                   {RBRACE}
| ';'                   {SEMI}
| ','      	            {COMMA}
| '='                   {ASSIGN}
| '.'                   {POINT}
| ':'                   {COLON}

(*key words*)
|"Image"                {IMAGE}
|"JumpButton"           {JUMPBUTTON}
|"Question"	            {QUESTION}
|"QuestionSet"          {QUESTIONSET}


|"SingleSelection"      {SINGLE}
|"MultipleSelection"    {MULTIPLE}
|"DropdownList"	        {DROP}
|"TextField"	        {TEXT}
|"Title"	       	    {TITLE}
|"Link"                 {LINK}
|"Jump"                 {JUMP}



|"New"		            {NEW}
|"AddQuestion"          {ADDQUESTION}


|"True"                 {TRUE}
|"False"                {FALSE}
|"SetTrue"              {SETTRUE}
|"Event"                {EVENT}


|"Display"				{DISPLAY}
|"oDisplay"             {ODISPLAY}
|"oqDisplay"            {OQDISPLAY}
|"qDisplay"             {QDISPLAY}
|"iDisplay"             {IDISPLAY}
|"jDisplay"             {JDISPLAY}

| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { ID(lxm) }
| ['0'-'9']+ as num { LITERAL(num) }
| '"'[^'"']*'"' as st { STRING_LITERAL(st) }


(*special character process*)
| _ as char { raise (Failure("illegal character " ^ Char.escaped char))}

| eof { EOF }

and comment = parse
  "*/" { token lexbuf }
| _    { comment lexbuf }

